// -*-c++-*-
/* $Id: sfssd.h,v 1.5 1999/02/14 06:15:36 dm Exp $ */

/*
 *
 * Copyright (C) 1999 David Mazieres (dm@uun.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */

#include "arpc.h"
#include "sfsmisc.h"
#include "list.h"

struct sfssrv {
  /* What requests to hand over to this server */
  str host;
  rpc_ptr<sfs_hash> hostid;
  u_int32_t release_min;
  u_int32_t release_max;
  int service;

  /* How to invoke this server */
  vector<str> argv;
  rpc_ptr<int> uid;
  rpc_ptr<int> gid;

  /* Copy of the server we are running */
  ptr<axprt_unix> x;

  list_entry<sfssrv> link;
  int line;

private:
  void setprivs ();
  void getpkt (const char *, ssize_t, const sockaddr *);

public:
  bool insert ();
  void launch ();
};

extern list<sfssrv, &sfssrv::link> srvlist;
