// -*-c++-*-
/* This file was automatically generated by rpcc. */

#ifndef __RPCC_SFSAGENT_H_INCLUDED__
#define __RPCC_SFSAGENT_H_INCLUDED__ 1

#include "xdrmisc.h"
#include "sfs_prot.h"


struct sfsagent_authinit_arg {
  int32_t ntries;
  rpc_str<RPC_INFINITY> requestor;
  sfs_authinfo authinfo;
  sfs_seqno seqno;
};
void *sfsagent_authinit_arg_alloc ();
bool_t xdr_sfsagent_authinit_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsagent_authinit_arg)

template<class T> bool
rpc_traverse (T &t, sfsagent_authinit_arg &obj)
{
  return rpc_traverse (t, obj.ntries)
    && rpc_traverse (t, obj.requestor)
    && rpc_traverse (t, obj.authinfo)
    && rpc_traverse (t, obj.seqno);
}



struct sfsagent_authmore_arg {
  sfs_authinfo authinfo;
  sfs_seqno seqno;
  rpc_bytes<RPC_INFINITY> challenge;
};
void *sfsagent_authmore_arg_alloc ();
bool_t xdr_sfsagent_authmore_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsagent_authmore_arg)

template<class T> bool
rpc_traverse (T &t, sfsagent_authmore_arg &obj)
{
  return rpc_traverse (t, obj.authinfo)
    && rpc_traverse (t, obj.seqno)
    && rpc_traverse (t, obj.challenge);
}



struct sfsagent_auth_res {
  const bool authenticate;
  union {
    union_entry_base _base;
    union_entry<rpc_bytes<RPC_INFINITY> > certificate;
  };

#define rpcunion_tag_sfsagent_auth_res authenticate
#define rpcunion_switch_sfsagent_auth_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case true: \
    action (opaque, certificate); \
    break; \
  case false: \
    voidaction; \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfsagent_auth_res (bool _tag = (bool) 0) : authenticate (_tag)
    { _base.init (); set_authenticate (_tag); }
  sfsagent_auth_res (const sfsagent_auth_res &_s)
    : authenticate (_s.authenticate)
    { _base.init (_s._base); }
  ~sfsagent_auth_res () { _base.destroy (); }
  sfsagent_auth_res &operator= (const sfsagent_auth_res &_s) {
    const_cast<bool &> (authenticate) = _s.authenticate;
    _base.assign (_s._base);
    return *this;
  }

  void set_authenticate (bool _tag) {
    const_cast<bool &> (authenticate) = _tag;
    rpcunion_switch_sfsagent_auth_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsagent_auth_res &obj)
{
  bool tag = obj.authenticate;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.authenticate)
    obj.set_authenticate (tag);

  rpcunion_switch_sfsagent_auth_res
    (obj.authenticate, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsagent_auth_res &obj)
{
  rpcunion_switch_sfsagent_auth_res
    (obj.authenticate, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsagent_auth_res_alloc ();
bool_t xdr_sfsagent_auth_res (XDR *, void *);
RPC_UNION_DECL (sfsagent_auth_res)


typedef rpc_str<1023> sfsagent_comment;
void *sfsagent_comment_alloc ();
bool_t xdr_sfsagent_comment (XDR *, void *);
RPC_TYPEDEF_DECL (sfsagent_comment)


struct sfs_addkey_arg {
  bigint p;
  bigint q;
  u_int32_t expire;
  sfsagent_comment comment;
};
void *sfs_addkey_arg_alloc ();
bool_t xdr_sfs_addkey_arg (XDR *, void *);
RPC_STRUCT_DECL (sfs_addkey_arg)

template<class T> bool
rpc_traverse (T &t, sfs_addkey_arg &obj)
{
  return rpc_traverse (t, obj.p)
    && rpc_traverse (t, obj.q)
    && rpc_traverse (t, obj.expire)
    && rpc_traverse (t, obj.comment);
}


typedef sfs_pubkey sfs_remkey_arg;
void *sfs_remkey_arg_alloc ();
bool_t xdr_sfs_remkey_arg (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_remkey_arg)


struct sfs_keylistelm {
  bigint key;
  u_int32_t expire;
  sfsagent_comment comment;
  rpc_ptr<sfs_keylistelm> next;
};
void *sfs_keylistelm_alloc ();
bool_t xdr_sfs_keylistelm (XDR *, void *);
RPC_STRUCT_DECL (sfs_keylistelm)

template<class T> bool
rpc_traverse (T &t, sfs_keylistelm &obj)
{
  return rpc_traverse (t, obj.key)
    && rpc_traverse (t, obj.expire)
    && rpc_traverse (t, obj.comment)
    && rpc_traverse (t, obj.next);
}


typedef rpc_ptr<sfs_keylistelm> sfs_keylist;
void *sfs_keylist_alloc ();
bool_t xdr_sfs_keylist (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_keylist)

typedef rpc_str<1023> sfsagent_path;
void *sfsagent_path_alloc ();
bool_t xdr_sfsagent_path (XDR *, void *);
RPC_TYPEDEF_DECL (sfsagent_path)


struct sfsagent_symlink_arg {
  sfs_hostname name;
  sfsagent_path contents;
};
void *sfsagent_symlink_arg_alloc ();
bool_t xdr_sfsagent_symlink_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsagent_symlink_arg)

template<class T> bool
rpc_traverse (T &t, sfsagent_symlink_arg &obj)
{
  return rpc_traverse (t, obj.name)
    && rpc_traverse (t, obj.contents);
}



struct sfsagent_lookup_res {
  const bool makelink;
  union {
    union_entry_base _base;
    union_entry<sfsagent_path> path;
  };

#define rpcunion_tag_sfsagent_lookup_res makelink
#define rpcunion_switch_sfsagent_lookup_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case true: \
    action (sfsagent_path, path); \
    break; \
  case false: \
    voidaction; \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfsagent_lookup_res (bool _tag = (bool) 0) : makelink (_tag)
    { _base.init (); set_makelink (_tag); }
  sfsagent_lookup_res (const sfsagent_lookup_res &_s)
    : makelink (_s.makelink)
    { _base.init (_s._base); }
  ~sfsagent_lookup_res () { _base.destroy (); }
  sfsagent_lookup_res &operator= (const sfsagent_lookup_res &_s) {
    const_cast<bool &> (makelink) = _s.makelink;
    _base.assign (_s._base);
    return *this;
  }

  void set_makelink (bool _tag) {
    const_cast<bool &> (makelink) = _tag;
    rpcunion_switch_sfsagent_lookup_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsagent_lookup_res &obj)
{
  bool tag = obj.makelink;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.makelink)
    obj.set_makelink (tag);

  rpcunion_switch_sfsagent_lookup_res
    (obj.makelink, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsagent_lookup_res &obj)
{
  rpcunion_switch_sfsagent_lookup_res
    (obj.makelink, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsagent_lookup_res_alloc ();
bool_t xdr_sfsagent_lookup_res (XDR *, void *);
RPC_UNION_DECL (sfsagent_lookup_res)



struct sfsctl_getfh_arg {
  filename3 filesys;
  u_int64_t fileid;
};
void *sfsctl_getfh_arg_alloc ();
bool_t xdr_sfsctl_getfh_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsctl_getfh_arg)

template<class T> bool
rpc_traverse (T &t, sfsctl_getfh_arg &obj)
{
  return rpc_traverse (t, obj.filesys)
    && rpc_traverse (t, obj.fileid);
}



struct sfsctl_getfh_res {
  const nfsstat3 status;
  union {
    union_entry_base _base;
    union_entry<nfs_fh3> fh;
  };

#define rpcunion_tag_sfsctl_getfh_res status
#define rpcunion_switch_sfsctl_getfh_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case NFS3_OK: \
    action (nfs_fh3, fh); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsctl_getfh_res (nfsstat3 _tag = (nfsstat3) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsctl_getfh_res (const sfsctl_getfh_res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsctl_getfh_res () { _base.destroy (); }
  sfsctl_getfh_res &operator= (const sfsctl_getfh_res &_s) {
    const_cast<nfsstat3 &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (nfsstat3 _tag) {
    const_cast<nfsstat3 &> (status) = _tag;
    rpcunion_switch_sfsctl_getfh_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsctl_getfh_res &obj)
{
  nfsstat3 tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsctl_getfh_res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsctl_getfh_res &obj)
{
  rpcunion_switch_sfsctl_getfh_res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsctl_getfh_res_alloc ();
bool_t xdr_sfsctl_getfh_res (XDR *, void *);
RPC_UNION_DECL (sfsctl_getfh_res)



struct sfsctl_getidnames_arg {
  filename3 filesys;
  sfs_idnums nums;
};
void *sfsctl_getidnames_arg_alloc ();
bool_t xdr_sfsctl_getidnames_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsctl_getidnames_arg)

template<class T> bool
rpc_traverse (T &t, sfsctl_getidnames_arg &obj)
{
  return rpc_traverse (t, obj.filesys)
    && rpc_traverse (t, obj.nums);
}



struct sfsctl_getidnames_res {
  const nfsstat3 status;
  union {
    union_entry_base _base;
    union_entry<sfs_idnames> names;
  };

#define rpcunion_tag_sfsctl_getidnames_res status
#define rpcunion_switch_sfsctl_getidnames_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case NFS3_OK: \
    action (sfs_idnames, names); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsctl_getidnames_res (nfsstat3 _tag = (nfsstat3) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsctl_getidnames_res (const sfsctl_getidnames_res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsctl_getidnames_res () { _base.destroy (); }
  sfsctl_getidnames_res &operator= (const sfsctl_getidnames_res &_s) {
    const_cast<nfsstat3 &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (nfsstat3 _tag) {
    const_cast<nfsstat3 &> (status) = _tag;
    rpcunion_switch_sfsctl_getidnames_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsctl_getidnames_res &obj)
{
  nfsstat3 tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsctl_getidnames_res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsctl_getidnames_res &obj)
{
  rpcunion_switch_sfsctl_getidnames_res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsctl_getidnames_res_alloc ();
bool_t xdr_sfsctl_getidnames_res (XDR *, void *);
RPC_UNION_DECL (sfsctl_getidnames_res)



struct sfsctl_getidnums_arg {
  filename3 filesys;
  sfs_idnames names;
};
void *sfsctl_getidnums_arg_alloc ();
bool_t xdr_sfsctl_getidnums_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsctl_getidnums_arg)

template<class T> bool
rpc_traverse (T &t, sfsctl_getidnums_arg &obj)
{
  return rpc_traverse (t, obj.filesys)
    && rpc_traverse (t, obj.names);
}



struct sfsctl_getidnums_res {
  const nfsstat3 status;
  union {
    union_entry_base _base;
    union_entry<sfs_idnums> nums;
  };

#define rpcunion_tag_sfsctl_getidnums_res status
#define rpcunion_switch_sfsctl_getidnums_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case NFS3_OK: \
    action (sfs_idnums, nums); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsctl_getidnums_res (nfsstat3 _tag = (nfsstat3) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsctl_getidnums_res (const sfsctl_getidnums_res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsctl_getidnums_res () { _base.destroy (); }
  sfsctl_getidnums_res &operator= (const sfsctl_getidnums_res &_s) {
    const_cast<nfsstat3 &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (nfsstat3 _tag) {
    const_cast<nfsstat3 &> (status) = _tag;
    rpcunion_switch_sfsctl_getidnums_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsctl_getidnums_res &obj)
{
  nfsstat3 tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsctl_getidnums_res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsctl_getidnums_res &obj)
{
  rpcunion_switch_sfsctl_getidnums_res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsctl_getidnums_res_alloc ();
bool_t xdr_sfsctl_getidnums_res (XDR *, void *);
RPC_UNION_DECL (sfsctl_getidnums_res)



struct sfsctl_getcred_res {
  const nfsstat3 status;
  union {
    union_entry_base _base;
    union_entry<sfs_cred> cred;
  };

#define rpcunion_tag_sfsctl_getcred_res status
#define rpcunion_switch_sfsctl_getcred_res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case NFS3_OK: \
    action (sfs_cred, cred); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsctl_getcred_res (nfsstat3 _tag = (nfsstat3) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsctl_getcred_res (const sfsctl_getcred_res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsctl_getcred_res () { _base.destroy (); }
  sfsctl_getcred_res &operator= (const sfsctl_getcred_res &_s) {
    const_cast<nfsstat3 &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (nfsstat3 _tag) {
    const_cast<nfsstat3 &> (status) = _tag;
    rpcunion_switch_sfsctl_getcred_res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsctl_getcred_res &obj)
{
  nfsstat3 tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsctl_getcred_res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsctl_getcred_res &obj)
{
  rpcunion_switch_sfsctl_getcred_res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsctl_getcred_res_alloc ();
bool_t xdr_sfsctl_getcred_res (XDR *, void *);
RPC_UNION_DECL (sfsctl_getcred_res)



struct sfsctl_lookup_arg {
  filename3 filesys;
  diropargs3 arg;
};
void *sfsctl_lookup_arg_alloc ();
bool_t xdr_sfsctl_lookup_arg (XDR *, void *);
RPC_STRUCT_DECL (sfsctl_lookup_arg)

template<class T> bool
rpc_traverse (T &t, sfsctl_lookup_arg &obj)
{
  return rpc_traverse (t, obj.filesys)
    && rpc_traverse (t, obj.arg);
}


#ifndef AGENTCTL_PROG
#define AGENTCTL_PROG 344428
#endif /* !AGENTCTL_PROG */
extern const rpc_program agentctl_prog_1;
enum { AGENTCTL_VERS = 1 };
enum {
  AGENTCTL_NULL = 0,
  AGENTCTL_ADDKEY = 1,
  AGENTCTL_REMKEY = 2,
  AGENTCTL_REMALL = 3,
  AGENTCTL_DUMP = 4,
  AGENTCTL_SYMLINK = 5,
};
#define AGENTCTL_PROG_1_APPLY_NOVOID(macro, void) \
  macro (AGENTCTL_NULL, void, void) \
  macro (AGENTCTL_ADDKEY, sfs_addkey_arg, bool) \
  macro (AGENTCTL_REMKEY, sfs_remkey_arg, bool) \
  macro (AGENTCTL_REMALL, void, void) \
  macro (AGENTCTL_DUMP, void, sfs_keylist) \
  macro (AGENTCTL_SYMLINK, sfsagent_symlink_arg, void)
#define AGENTCTL_PROG_1_APPLY(macro) \
  AGENTCTL_PROG_1_APPLY_NOVOID(macro, void)


#ifndef SETUID_PROG
#define SETUID_PROG 344430
#endif /* !SETUID_PROG */
extern const rpc_program setuid_prog_1;
enum { SETUID_VERS = 1 };
enum {
  SETUIDPROC_SETUID = 0,
};
#define SETUID_PROG_1_APPLY_NOVOID(macro, void) \
  macro (SETUIDPROC_SETUID, void, int32_t)
#define SETUID_PROG_1_APPLY(macro) \
  SETUID_PROG_1_APPLY_NOVOID(macro, void)


#ifndef AGENT_PROG
#define AGENT_PROG 344432
#endif /* !AGENT_PROG */
extern const rpc_program agent_prog_1;
enum { AGENT_VERS = 1 };
enum {
  AGENT_NULL = 0,
  AGENT_START = 1,
  AGENT_KILL = 2,
  AGENT_KILLSTART = 3,
  AGENT_SYMLINK = 4,
  AGENT_FLUSHNAME = 5,
};
#define AGENT_PROG_1_APPLY_NOVOID(macro, void) \
  macro (AGENT_NULL, void, void) \
  macro (AGENT_START, void, int32_t) \
  macro (AGENT_KILL, void, int32_t) \
  macro (AGENT_KILLSTART, void, int32_t) \
  macro (AGENT_SYMLINK, sfsagent_symlink_arg, void) \
  macro (AGENT_FLUSHNAME, sfs_hostname, void)
#define AGENT_PROG_1_APPLY(macro) \
  AGENT_PROG_1_APPLY_NOVOID(macro, void)


#ifndef AGENTCB_PROG
#define AGENTCB_PROG 344433
#endif /* !AGENTCB_PROG */
extern const rpc_program agentcb_prog_1;
enum { AGENTCB_VERS = 1 };
enum {
  AGENTCB_NULL = 0,
  AGENTCB_AUTHINIT = 1,
  AGENTCB_AUTHMORE = 2,
  AGENTCB_LOOKUP = 3,
};
#define AGENTCB_PROG_1_APPLY_NOVOID(macro, void) \
  macro (AGENTCB_NULL, void, void) \
  macro (AGENTCB_AUTHINIT, sfsagent_authinit_arg, sfsagent_auth_res) \
  macro (AGENTCB_AUTHMORE, sfsagent_authmore_arg, sfsagent_auth_res) \
  macro (AGENTCB_LOOKUP, sfs_hostname, sfsagent_lookup_res)
#define AGENTCB_PROG_1_APPLY(macro) \
  AGENTCB_PROG_1_APPLY_NOVOID(macro, void)


#ifndef SFSCTL_PROG
#define SFSCTL_PROG 344434
#endif /* !SFSCTL_PROG */
extern const rpc_program sfsctl_prog_1;
enum { SFSCTL_VERS = 1 };
enum {
  SFSCTL_NULL = 0,
  SFSCTL_SETPID = 1,
  SFSCTL_GETFH = 2,
  SFSCTL_GETIDNAMES = 3,
  SFSCTL_GETIDNUMS = 4,
  SFSCTL_GETCRED = 5,
  SFSCTL_LOOKUP = 6,
};
#define SFSCTL_PROG_1_APPLY_NOVOID(macro, void) \
  macro (SFSCTL_NULL, void, void) \
  macro (SFSCTL_SETPID, int32_t, void) \
  macro (SFSCTL_GETFH, sfsctl_getfh_arg, sfsctl_getfh_res) \
  macro (SFSCTL_GETIDNAMES, sfsctl_getidnames_arg, sfsctl_getidnames_res) \
  macro (SFSCTL_GETIDNUMS, sfsctl_getidnums_arg, sfsctl_getidnums_res) \
  macro (SFSCTL_GETCRED, filename3, sfsctl_getcred_res) \
  macro (SFSCTL_LOOKUP, sfsctl_lookup_arg, lookup3res)
#define SFSCTL_PROG_1_APPLY(macro) \
  SFSCTL_PROG_1_APPLY_NOVOID(macro, void)

#endif /* !__RPCC_SFSAGENT_H_INCLUDED__ */
